//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     Orange
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern int    RegressionPeriod = 10;
extern int    RegressionPrice  = PRICE_MEDIAN;
extern int    SmoothPeriod     = 5;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundFile        = "alert2.wav";


double slope[];
double lra[];
double lrb[];
double trend[];
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(4);
   SetIndexBuffer(0,slope);
   SetIndexBuffer(1,lra);
   SetIndexBuffer(2,lrb);
   SetIndexBuffer(3,trend);
   SetLevelValue(0,0);
      IndicatorShortName("Linear regression slope ("+RegressionPeriod+")");
   return(0);
}

//
//
//
//
//

double  work[][2];
#define _price  0
#define _prices 1

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
           if (trend[limit]==-1) CleanPoint(limit,lra,lrb);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,RegressionPrice,i);

         double sump =0, sumw=0;
         for (int k=0; k<MathMax(SmoothPeriod,1); k++)
         {
            double weight = (RegressionPeriod-k)*(RegressionPeriod-k);
                   sump  += weight*work[r-k][_price];
                   sumw  += weight;
         }
         work[r][_prices] = MathLog(sump/sumw);
            
         //
         //
         //
         //
         //
                                    
         double sumx=0, sumxx=0, sumxy=0, sumy=0;
         for (k=0; k<RegressionPeriod; k++)
         {
            double price = work[r-k][_prices];
                   sumx  += k;
                   sumxx += k*k;
                   sumxy += k*price;
                   sumy  +=   price;
         }
         slope[i] = (RegressionPeriod*sumxy - sumx*sumy)/(sumx*sumx-RegressionPeriod*sumxx );
         lra[i]   = EMPTY_VALUE;   
         lrb[i]   = EMPTY_VALUE; 
         trend[i] = trend[i+1];
         if (slope[i]>slope[i+1]) trend[i] = 1;  
         if (slope[i]<slope[i+1]) trend[i] =-1;  
         if (trend[i]==-1) PlotPoint(i,lra,lrb,slope); 
         
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Sloping up");
      else  doAlert("Sloping down");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Linear regression slope smoothed ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Linear regression slope smoothed "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}